"""
   Copyright 2009 Glenn Johnson

   Licensed under the Apache License, Version 2.0 (the "License");
   you may not use this file except in compliance with the License.
   You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
"""

import datetime

class Render(object):
    def details(self, html, stock, cash):
	html.SetPage("<title>%s</title>"
		% stock.symbol.upper())
	html.AppendToPage("<table border=1 width=100%>")
	html.AppendToPage(
		"""
		<tr>
		<td width=220>Symbol</td>
		<td width=340>
		<a href=http://finance.yahoo.com/q?s=%s>%s</a>
		</td>
		</tr>
		<tr>
		<td>Description</td>
		<td>%s</td>
		</tr>
		"""
		% (stock.symbol,
		    stock.symbol.upper(),
		    stock.description,
		    )
		)
	if stock.initial_purchase_date:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Initial Purchase Date</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.initial_purchase_date
		    )
	if stock.buydate:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Last Buy Date</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.buydate
		    )
	if stock.selldate:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Last Sell Date</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.selldate
		    )
	if stock.price:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Price </td>
		    <td>$%f</td>
		    </tr>
		    """
		    % stock.price
		    )
	if stock.price_date:
	    html.AppendToPage(
		    """
		    <tr>
		    <td>Price Updated on</td>
		    <td>%s</td>
		    </tr>
		    """
		    % stock.price_date
		    )
	
	portfolio_value = (stock.stock + stock.cash)
	cash_flow = (stock.cash_in - stock.cash_out)
	try:
	    portfolio_return = (((portfolio_value - cash_flow)/cash_flow)*100)
	except:
	    portfolio_return = 0
	
	if portfolio_return > 0.0:
	    #pr_color = 'DarkGreen'
	    pr_color = '#006400'
	elif portfolio_return < 0:
	    #pr_color = 'DarkRed'
	    pr_color = '#8B0000'
	else:
	    pr_color = 'black'

	if stock.initial_purchase_date:
	    days = (float((datetime.date.today() -
		stock.initial_purchase_date).days))
	    if days > 0:
		annualized_return = (
			(portfolio_value/cash_flow)**(365/days)-1)*100
	    else:
		annualized_return = 0.0
	    if annualized_return > 0.0:
		#ar_color = 'DarkGreen'
		ar_color = '#006400'
	    elif annualized_return < 0:
		#ar_color = 'DarkRed'
		ar_color = '#8B0000'
	    else:
		ar_color = 'Black'
	
	    html.AppendToPage(
		    """
		    <tr>
		    <td bgcolor=#DCDCDC>
		    <font color=%s><b>Total Portfolio Return</b></font>
		    </td>
		    <td bgcolor=#DCDCDC>
		    <font color=%s><b>%.2f%%</b></font></td>
		    </tr>
		    <tr>
		    <td bgcolor=#DCDCDC>
		    <font color=%s><b>Annualized Portfolio Return</b></font>
		    </td>
		    <td bgcolor=#DCDCDC>
		    <font color=%s><b>%.2f%%</b></font></td>
		    </tr>
		    """
		    % (
			pr_color, pr_color,
			portfolio_return,
			ar_color, ar_color,
			annualized_return
			)
		    )

	html.AppendToPage(
		"""
		<tr>
		<td>Shares</td>
		<td>%.5f</td>
		</tr>
		<tr>
		<td>Stock Value</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Cash</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Portfolio Value</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Dividends</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Capital Gain Distributions</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Cash In</td>
		<td>$%.2f</td>
		</tr>
		<tr>
		<td>Cash Out</td>
		<td>$%.2f</td>
		</tr>
		"""
		% (
		    stock.shares,
		    stock.stock,
		    stock.cash,
		    portfolio_value,
		    stock.dividends,
		    stock.capital_gains,
		    stock.cash_in,
		    stock.cash_out,
		    )
		)

	if stock.stock:
	    next_buy_stock = (stock.buy_portfolio_control/
		    (1 + stock.scaled_buy_resistance/100 + stock.min_buy/100))
	    next_buy_amount = ((stock.buy_portfolio_control - next_buy_stock) -
		    (stock.scaled_buy_resistance/100 * next_buy_stock))
	    next_buy_price = (next_buy_stock/stock.shares)
	    next_buy_shares = (next_buy_amount/next_buy_price)

	    next_sell_stock = (-stock.sell_portfolio_control/
		    (stock.scaled_sell_resistance/100 + stock.min_sell/100 -1))
	    next_sell_amount = ((next_sell_stock - stock.sell_portfolio_control) -
		    (stock.scaled_sell_resistance/100 * next_sell_stock))
	    next_sell_price = (next_sell_stock/stock.shares)
	    next_sell_shares = (next_sell_amount/next_sell_price)

	    html.AppendToPage(
		    """
		    <tr>
		    <td bgcolor=#F08080>Approximate Next Minimum Buy</td>
		    <td bgcolor=#F08080>%.5f shares at $%.2f for $%.2f</td>
		    </tr>
		    <tr>
		    <td bgcolor=#90EE90>Approximate Next Minimum Sell</td>
		    <td bgcolor=#90EE90>%.5f shares at $%.2f for $%.2f</td>
		    </tr>
		    """
		    % (
			next_buy_shares,
			next_buy_price,
			next_buy_amount,
			next_sell_shares,
			next_sell_price,
			next_sell_amount,
			)
		    )

	html.AppendToPage(
		"""
		<tr>
		<td>Core Portfolio Control</td>
		<td>%f</td>
		</tr>
		<tr>
		<td>Sell Portfolio Control</td>
		<td>%f</td>
		</tr>
		<tr>
		<td>Buy Portfolio Control</td>
		<td>%f</td>
		</tr>
		"""
		% (
		    stock.portfolio_control,
		    stock.sell_portfolio_control,
		    stock.buy_portfolio_control,
		    )
		)
	html.AppendToPage(
		"""
		</table>
		"""
		)

    def recs(self, html, db):
	cash = db['cash']
	total_stock = 0
	total_cash = cash.free
	html.SetPage("<title>Action List</title>")
	html.AppendToPage("<center>")
	html.AppendToPage(
		"""
		<h1>Action List</h1>
		<h3>Generated: %s</h3>
		"""
		% datetime.datetime.now().ctime()
		)
	html.AppendToPage("<table border=1 width=100%>")
	html.AppendToPage(
		"""
		<tr>
		<th><b>Symbol</b></th>
		<th width=40%><b>Description</b></th>
		<th><b>Stock</b></th>
		<th><b>Cash</b></th>
		<th><b>% Cash</b></th>
		<th><b>Action</b></th>
		<th><b>Amount</b></th>
		</tr>
		"""
		)
	html.AppendToPage(
		"""
		<tr>
		<td>CASH</td>
		<td colspan=2>Unallocated Cash</td>
		<td align=right>$%.2f</td>
		<td colspan=3></td>
		</tr>
		"""
		% cash.free
		)
	D = db['portfolios']
	for key in sorted(D.keys()):
	    if D[key].rec:
		bgcolor='yellow'
	    else:
		if D[key].stock > D[key].sell_portfolio_control:
		    #bgcolor = 'LightGreen'
		    bgcolor = '#90EE90'
		elif D[key].stock < D[key].buy_portfolio_control:
		    #bgcolor = 'LightCoral'
		    bgcolor = '#F08080'
		else:
		    bgcolor='white'
	    html.AppendToPage(
		    """
		    <tr>
		    <td bgcolor=%s>%s</td>
		    <td bgcolor=%s>%s</td>
		    <td bgcolor=%s align=right>$%.2f</td>
		    <td bgcolor=%s align=right>$%.2f</td>
		    <td bgcolor=%s align=right>%.2f</td>
		    """
		    % (
			bgcolor, D[key].symbol.upper(),
			bgcolor, D[key].description,
			bgcolor, D[key].stock,
			bgcolor, D[key].cash,
			bgcolor, D[key].cash_level,
			)
		    )
	    if not D[key].rec:
		html.AppendToPage(
			"""
			<td></td>
			<td></td>
			</tr>
			"""
			)
	    else:
		if D[key].rec == 'BUY':
		    color = 'red'
		else:
		    color = 'green'
		html.AppendToPage(
			"""
			<td align=center bgcolor=%s>
			<font color=%s>
			<b>%s</b>
			</font>
			</td>
			<td bgcolor=%s align=right>
			<font color=%s><b>$%.2f</b></font>
			</td>
			</tr>
			"""
			% (
			    bgcolor, color, D[key].rec,
			    bgcolor, color, D[key].rec_amount
			    )
			)
	    total_stock += D[key].stock
	    total_cash += D[key].cash
	if total_cash and total_stock:
	    html.AppendToPage(
		    """
		    <tr>
		    <td colspan=2 align=center><b>%s</b></td>
		    <td align=right><b>$%.2f</b></td>
		    <td align=right><b>$%.2f</b></td>
		    <td align=right><b>%.2f</b></td>
		    <td colspan=2></td>
		    </tr>
		    """
		    % (
			"Totals",
			total_stock,
			total_cash,
			total_cash/(total_cash+total_stock)*100
			)
		    )

	html.AppendToPage("</table>")
	html.AppendToPage("</center>")
